template <typename T, int n, typename sum = std::plus<T> >
class Aib {
private:
	T* aib;
	T neutral;
	sum adder;
	inline int lsb(int x) {
		return x & (-x);
	}
public:
	Aib(T _neutral) {
		aib = new T[1+n];
		for(int i = 1; i <= n; ++i)
			aib[i] = neutral;
		neutral = _neutral;
	}
	void update(int poz, T val) {
		while(poz <= n) {
			this->aib[poz] = adder(this->aib[poz], val);
			poz += this->lsb(poz);
		}
	}
	T query(int poz) {
		T rez = this->aib[poz];
		poz -= this->lsb(poz);
		while(poz > 0) {
			rez = adder(this->aib[poz], rez);
			poz -= this->lsb(poz);
		}
		return rez;
	}
};

