template<int n, typename T, typename Updater>
class Aint {
private:
	T neutralQry, initval;
	T *aint;
	Updater upd;
public:
	Aint(T _neutralQry, T _initval) {
		initval = _initval;
		neutralQry = _neutralQry;

		aint = new T[1 + 4 * n];
		
		for(int i = 0; i <= 4 * n; ++i)
			aint[i] = initval;
	}
	void update(int poz, T val, int nod = 1, int l = 1, int r = n) {
		if(poz < l || r < poz)
			return ;
		if(l == r && l == poz)
			aint[nod] = upd.update(aint[nod], val);

		int mid = (l + r) / 2;
		if(l < r) {
			update(poz, val, 2 * nod, l, mid);
			update(poz, val, 2 * nod + 1, mid + 1, r);
			aint[nod] = upd.query(aint[2 * nod], aint[2 * nod + 1]);
		}
	}
	T query(int i, int j, int nod = 1, int l = 1, int r = n) {
		if(r < i || j < l || r < l)
			return neutralQry;
		if(i <= l && r <= j)
			return aint[nod];
		int mid = (l + r) / 2;
		return upd.query(query(i, j, 2 * nod, l, mid),
		                 query(i, j, 2 * nod + 1, mid + 1, r));
	}
};
