struct BinaryLifting {
	Tree *T;
	int N;
	int maxlg, lastRoot;
	int **ancestor;
	
	BinaryLifting(int n) {
		N = n;
		maxlg = 0;
		while((1 << maxlg) < N)
			++maxlg;
		ancestor = new int*[1+maxlg];
		for(int i = 0; i <= maxlg; ++i) {
			ancestor[i] = new int[1 + N];
			memset(ancestor[i], 0, sizeof(int) * (1 + N));
		}
	}

	BinaryLifting(Tree *_T):T(_T) {
		N = T->N;
		maxlg = 0;
		while((1 << maxlg) < T->N)
			++maxlg;
		
		ancestor = new int*[1+maxlg];
		for(int i = 0; i <= maxlg; ++i) {
			ancestor[i] = new int[1 + T->N];
			memset(ancestor[i], 0, sizeof(int) * (1 + T->N));
		}
		
		lastRoot = 0;
	}

	void ancestryDfs(int nod, int papa = 0) {
		ancestor[0][nod] = papa;
		for(int i = 1; i <= maxlg; ++i)
			ancestor[i][nod] = ancestor[i - 1][ancestor[i - 1][nod]];
		for(auto it: T->G[nod])
			if(it != papa)
				ancestryDfs(it, nod);
	}

	void setAncestor(int nod, int anc) {
		ancestor[0][nod] = anc;
	}

	void resetAncestor(int nod, int anc) {
		ancestor[0][nod] = anc;
		for(int i = 1; i <= maxlg; ++i)
			ancestor[i][nod] = ancestor[i - 1][ancestor[i - 1][nod]];
	}

	void ancestryLiniar() {
		for(int i = 1; i <= maxlg; ++i)
			for(int nod = 1; nod <= N; ++nod)
				ancestor[i][nod] = ancestor[i - 1][ancestor[i - 1][nod]];
	}

	void computeAncestry(int root = 1) {
		if(T == NULL) {
			ancestryLiniar();
		} else if(lastRoot != root) {
			lastRoot = root;
			ancestor[0][root] = 0;
			ancestryDfs(1);
		}
	}

	int goUp(int nod, int x) {
		if(x >= N)
			return 0;
		for(int i = 0; i <= maxlg; ++i)
			if((1 << i) & x)
				nod = ancestor[i][nod];
		return nod;
	}
};
