template<int n, typename T, typename Updater>
class LazyAint {
private:
	T neutralUpd, neutralQry, initval;
	T *aint;
	T *lazy;
	Updater upd;

	void pushlazy(int nod, int l, int r) {
		aint[nod] = upd.update(aint[nod], lazy[nod], r - l + 1);
		
		if(2 * nod <= 4 * n)
			lazy[2 * nod] = upd.update(lazy[2 * nod], lazy[nod], r - l + 1);
		if(2 * nod + 1 <= 4 * n)
			lazy[2 * nod + 1] = upd.update(lazy[2 * nod + 1], lazy[nod], r - l + 1);
		lazy[nod] = neutralUpd;
	}
public:
	Aint(T _neutralUpd, T _neutralQry, T _initval) {
		neutralUpd = _neutralUpd;
		neutralQry = _neutralQry;
		initval = _initval;

		aint = new T[1 + 4 * n];
		lazy = new T[1 + 4 * n];
		
		for(int i = 0; i <= 4 * n; ++i)
			aint[i] = lazy[i] = initval;
	}
	void update(int i, int j, T val, int nod = 1, int l = 1, int r = n) {
		if(r < i || j < l || r < l)
			return ;
		if(i <= l && r <= j) {
			lazy[nod] = upd.update(lazy[nod], val, r - l + 1);
			pushlazy(nod, l, r);
			return;
		}
		int mid = (l + r) / 2;
		pushlazy(nod, l, r);
		if(l < r) {
			update(i, j, val, 2 * nod, l, mid);
			update(i, j, val, 2 * nod + 1, mid + 1, r);
			aint[nod] = upd.query(aint[2 * nod], aint[2 * nod + 1]);
		}
	}
	T query(int i, int j, int nod = 1, int l = 1, int r = n) {
		if(r < i || j < l || r < l)
			return neutralQry;
		pushlazy(nod, l, r);
		if(i <= l && r <= j)
			return aint[nod];
		int mid = (l + r) / 2;
		return upd.query(query(i, j, 2 * nod, l, mid),
		                 query(i, j, 2 * nod + 1, mid + 1, r));
	}
};
