struct LCA {
	BinaryLifting *bl;
	Tree *T;
	int lastRoot;

	LCA(Tree *_T):T(_T) {
		lastRoot = 0;
		bl = new BinaryLifting(T);
	}

	void computeAncestry(int root) {
		if(root != lastRoot) {
			bl->computeAncestry(root);
			T->calculateStatistics(root);
			lastRoot = root;
		}
	}
	
	int getLca(int a, int b) {
		if(T->depth[a] > T->depth[b])
			a = bl->goUp(a, T->depth[a] - T->depth[b]);
		else
			b = bl->goUp(b, T->depth[b] - T->depth[a]);

		for(int i = bl->maxlg; i >= 0; --i)
			if(bl->ancestor[i][a] != bl->ancestor[i][b]) {
				a = bl->ancestor[i][a];
				b = bl->ancestor[i][b];
			}
		if(a != b)
			a = bl->ancestor[0][a];
		return a;
	}
	int getDist(int a, int b) {
		int x = getLca(a, b);
		return T->depth[a] + T->depth[b] - T->depth[x] * 2;
	}
};
