template <typename T, int n, typename sum = std::plus<T> >
class Rmq {
private:
	T** rmq;
	int* mylog;
	sum adder;
public:
	Rmq() {
		mylog = new int[1 + n];
		for(int i = 2; i <= n; ++i)
			mylog[i] = mylog[i / 2] + 1;

		rmq = new T*[1 + mylog[n]];
		for(int i = 0; i <= mylog[n]; ++i)
			rmq[i] = new T[n];
	}
	void loadRmq(T* vect) {
		for(int i = 0; i < n; ++i)
			rmq[0][i] = vect[i];

		for(int l = 1; l <= mylog[n]; ++l)
			for(int i = 0; i < n - (1 << l) + 1; ++i)
				rmq[l][i] = adder(rmq[l - 1][i], rmq[l - 1][i + (1 << (l - 1))]);
	}
	void loadRmq(vector<T> vect) {
		this->loadRmq(vect.get_allocator().allocate(n));
	}
	T operator() (int l, int r) {
		int s = (r - l + 1);
		int lg = mylog[s];

		return adder(rmq[lg][l], rmq[lg][r - (1 << lg) + 1]);
	}
};
