struct Tree {
	int N;
	std::vector<std::vector<int> > G;
	
	// Basic tree statistics
	int *label;
	int *subarb, *depth;
	int lastStatisticRoot;

	Tree(int _N) : N(_N) {
		G.resize(1+N);
		label = subarb = depth = NULL;
		lastStatisticRoot = 0;
	}

	void pushEdge(int a, int b) {
		G[a].push_back(b);
		G[b].push_back(a);
	}
	
	void statisticDfs(int root = 1, int father = 0) {
		subarb[root] = 1;
		for(auto it: G[root])
			if(it != father) {
				depth[it] = depth[root] + 1;
				statisticDfs(it, root);
				subarb[root] += subarb[it];
			}
	}

	void calculateStatistics(int root = 1) {
		if(subarb == NULL && depth == NULL) {
			subarb = new int[1+N];
			depth = new int[1+N];
		}

		if(lastStatisticRoot != root) {
			memset(subarb, 0, sizeof(int) * (1 + N));
			memset(depth,  0, sizeof(int) * (1 + N));
	
			statisticDfs(root);
		
			lastStatisticRoot = root;
		}
	}

	void allocLabels() {
		if(label == NULL)
			label = new int[1+N];
		memset(label, 0, sizeof(int) * (1 + N));
	}
};

